#include "crtlocal.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/errno.h>
#include <Aliases.h>

FSSpec getparent(FSSpec parID)	
    {
    FSSpec	name;
    OSErr err;
    CInfoPBRec  cPB;
    cPB.dirInfo.ioDrParID = parID.parID;
        /* get information about dir */
        cPB.hFileInfo.ioCompletion = (ProcPtr)0L;
        cPB.hFileInfo.ioNamePtr = (StringPtr)name.name;
        cPB.hFileInfo.ioVRefNum = parID.vRefNum;
        cPB.hFileInfo.ioFDirIndex = -1;
		cPB.hFileInfo.ioDirID = cPB.dirInfo.ioDrParID;

        err = PBGetCatInfoSync(&cPB); 
	if (err) *name.name = 0;
	name.parID = cPB.dirInfo.ioDrParID;
	name.vRefNum = parID.vRefNum;
	return name;
	}

FSSpec hfs_canon(FSSpec crt, const char *nam, int follow)
	{
	char	*nxt;
	FSSpec	canon;
	char name[255];
	int err;
	Boolean	targetIsFolder,wasAliased;
	struct stat statbuf;
	strcpy(name, nam);
	if (*name=='/') 
		{
		canon = root;
		strcpy(name, &name[1]);
		if (!*name) return getparent(canon);
		}
	else
		{
		canon = crt;
		if (!*name)
			{
			*canon.name = 0;
			return canon;
			}
		}
	do
		{
		nxt = strchr(name, '/');
		if (nxt)
			{
			*nxt = 0;
			canon = hfs_canon(canon, name, 1);
			err = macstat(canon.name, &statbuf, canon.vRefNum, canon.parID);
			if (err)
				{
				*canon.name = 0;
				return canon;
				}
			if (S_ISDIR(statbuf.st_mode))
				{
				canon.parID = statbuf.st_ino;
				}
			else
				{
				errno = ENOTDIR;
				*canon.name = 0;
				return canon;
				}
			strcpy(name, ++nxt);
			}
		}
	while (nxt);
	if (!*name) return getparent(canon);
	if (*name == '.')
		{
		if (!name[1])
			return getparent(canon);
		if ((name[1]=='.') && !name[2])
			{
			canon = getparent(canon);
			return getparent(canon);
			}
		}
	*canon.name = strlen(name);
	BlockMove(name, &canon.name[1], *canon.name);
	if (follow) err = ResolveAliasFile(&canon,true,&targetIsFolder,&wasAliased);
	return canon;
	}
	
int chdir(const char *name)
	{
	struct stat statbuf;
	int err;
	if (!*name) return 0;
	err = stat(name, &statbuf);
	if (S_ISDIR(statbuf.st_mode))
		{
		crt.parID = statbuf.st_ino;
		return 0;
		}
	errno = ENOTDIR;
	return -1;
	}

int fchdir(int fd)
	{
	if (crt_fd_tab[fd].flags & S_IFDIR)
		{
		crt.parID = crt_fd_tab[fd].fd;
		return 0;
		}
	return -1;
	}
