#ifndef THINK_C
#define SystemSevenOrLater 1
#endif
#include "crtlocal.h"
#include <setjmp.h>
#include <Dialogs.h>
#include <OSUtils.h>
#include <Resources.h>
#include <Processes.h>
#include <Folders.h>

jmp_buf vforkregs;

#ifdef THINK_C
#define __setjmp setjmp
#define _exit _exit_
#include <LoMem.h>
#define can CurApName
#else
#include <SysEqu.h>
#define can (char *)CurApName
#endif

enum {
	cmdLine = 3, labelLine, execute

};

static struct {
	short			count;
	struct {
		Handle			h;
		Rect			box;
		char			kind;
	}				item[13];
} itemList = { 5,

		/*  OK  */
	0, { 76, 100, 96, 160 }, ctrlItem+btnCtrl,

		/*  Cancel  */
	0, { 76, 210, 96, 270 }, ctrlItem+btnCtrl,
	
		/*  command line  */
	0, { 41, 34, 57, 376 }, editText+itemDisable,
		
		/*  "Command Line:"  */
	0, { 14, 20, 30, 170 }, statText+itemDisable,

		/*  Execute  */
	0, { 76, 320, 96, 380 }, ctrlItem+btnCtrl,
	
};

/*
 *  ditem - return item handle
 *
 */

static DialogPtr dp;

static Handle ditem(int);

static Handle ditem(int i)
{
	short kind;
	Handle item;
	Rect box;
	
	GetDItem(dp, i, &kind, &item, &box);
	return(item);
}

enum { NARGS = 255};

static int argc;
static Str255 argbuf;
static char *argvec[NARGS+1];
char newargs[256];

void parse(void)
        {
        char *s = newargs;
        char *t = newargs;
	int c = *s++, quote = 0;
	argc = 0;
	s[(unsigned char)c] = 0;
	while (c = *s++) {
		if (c == ' ')
			continue;
		if (argc < NARGS)
			argvec[argc++] = t;
		do {
			if (c == '\\' && *s)
				c = *s++;
			else if (c == '"' || c == '\'') {
				if (!quote) {
					quote = c;
					continue;
				}
				if (c == quote) {
					quote = 0;
					continue;
				}
			}
			*t++ = c;
		} while (*s && ((c = *s++) != ' ' || quote));
		*t++ = 0;
	}
	argvec[argc] = 0;
}

#include <Aliases.h>

char empty[1];
char *___progname = empty;

OSErr   CurrentProcessLocation(FSSpec *applicationSpec)
{
    ProcessSerialNumber currentPSN;
    ProcessInfoRec info;
    
    currentPSN.highLongOfPSN = 0;
    currentPSN.lowLongOfPSN = kCurrentProcess;
    info.processInfoLength = sizeof(ProcessInfoRec);
    info.processName = NULL;
    info.processAppSpec = applicationSpec;
    return ( GetProcessInformation(&currentPSN, &info) );
}

FSSpec *prefID(void)
	{
	OSErr err;
	static FSSpec tempID = {0};
	if (!tempID.parID)
		{
		err = FindFolder(kOnSystemDisk,kPreferencesFolderType,kDontCreateFolder,&tempID.vRefNum,&tempID.parID);
		}
	return &tempID;
	}

void BeginProcessing(void)
	{
	Boolean isFolder,wasAlias;
        FSSpec applicationSpec;
	OSErr err = CurrentProcessLocation(&applicationSpec);
        root = crt = applicationSpec;
        applicationSpec = *prefID();
        BlockMove("\proot", applicationSpec.name, 5);
	err = ResolveAliasFile (&applicationSpec, true, &isFolder, &wasAlias);
	if ((err == noErr) && isFolder && wasAlias)
		{
		CInfoPBRec  cPB;
		cPB.hFileInfo.ioNamePtr = applicationSpec.name;
		cPB.hFileInfo.ioVRefNum = applicationSpec.vRefNum;
		cPB.hFileInfo.ioDirID = applicationSpec.parID;
		cPB.hFileInfo.ioFDirIndex = 0;
		
		if (!PBGetCatInfoSync(&cPB))
			{
                        if (cPB.hFileInfo.ioFlAttrib & ioDirMask)
                            {
                            root.parID = cPB.dirInfo.ioDrDirID;
                            root.vRefNum = applicationSpec.vRefNum;
                            }
			}
		}
        ___progname = 1+(char *)can;
        ___progname[*can] = 0;
	BlockMove(can, newargs, 1+*can);
	newargs[1+*newargs] = ' ';
	BlockMove(&argbuf[1], &newargs[2+*newargs], *argbuf);
	newargs[0] += 1+*argbuf;
	}

void EndProcessing(void)
	{
    int console;
    for (console = 0; console < 3; console++)
            {
        	crt_fd_tab[console].fd = (100<<8);	/* console */
                crt_fd_tab[console].flags = O_RDWR|S_IFCHR;
            }
	if (!__setjmp(vforkregs))
            _exit(_main(argc, argvec));
    _exit(0);
	}

#if 1
/* avoid dragging in macTraps */
#pragma parameter __A0 myPtrToHand(__A0,__D0)
pascal Handle myPtrToHand(const void *srcPtr, long size) = 0xA9E3;
#endif

void crt_getargs(void)
   {
	short i;
	Rect bounds = { 60, 51, 170, 461 };
	Handle items;
#if 1
/* avoid dragging in macTraps */
	items = myPtrToHand(&itemList,sizeof(itemList));
#else
	i = PtrToHand(&itemList, &items, sizeof(itemList));
#endif
	dp = NewDialog(0, &bounds, (unsigned char *)"\006 line", 0, 1, (WindowPtr) -1, 0, 0, items);
	SetCTitle((ControlHandle)ditem(ok), (unsigned char *)"\003OK");
	SetCTitle((ControlHandle)ditem(cancel), (unsigned char *)"\006Cancel");
	SetCTitle((ControlHandle)ditem(execute), (unsigned char *)"\007Execute");
	SetIText(ditem(labelLine), (unsigned char *)"\015Command Line:");
	SetIText(ditem(cmdLine), (unsigned char *)"\000" );
	SelIText(dp, cmdLine, 9999, 9999);
	ShowWindow(dp);
	SetCursor(&qd.arrow);	
	do {
		ModalDialog(0, &i);
		if (i != cancel) GetIText(ditem(cmdLine), (void *)argbuf);
		}
	while ((i != ok) && (i != cancel) && (i != execute));
	if (i == execute)
		{
                BeginProcessing();
                parse();
                EndProcessing();
		}
	else DisposDialog(dp);
	}

void ProcessDoc (FSSpec *curDocFSS)
	{
	short refnum;
	crt = *curDocFSS;
	refnum = FSpOpenResFile(curDocFSS, fsRdPerm);
	if (refnum != -1)
		{
		StringHandle x = (StringHandle)Get1Resource('STR ', 12345);
		if (x && *x && **x)
			{
			unsigned char *argbuf = *x;
			newargs[1+*newargs] = ' ';
			BlockMove(&argbuf[1], &newargs[2+*newargs], *argbuf);
			newargs[0] += 1+*argbuf;
			}
		CloseResFile(refnum);
		}			
	newargs[1+*newargs] = ' ';
	BlockMove(&(curDocFSS->name[1]), &newargs[2+*newargs], *(curDocFSS->name));
	newargs[0] += 1+*(curDocFSS->name);
	UpdateFileName((StringPtr)newargs);
	}

void ProcessArg (FSSpec *curDocFSS)
            {
            short refnum;
	    OSErr err;
            int fd,i;
	    HParamBlockRec hpb;
	    IOParam pb;
            crt = *curDocFSS;
	    hpb.ioParam.ioNamePtr = curDocFSS->name;
	    hpb.ioParam.ioVRefNum = curDocFSS->vRefNum;
	    hpb.fileParam.ioDirID = curDocFSS->parID;
	    hpb.ioParam.ioPermssn = fsRdPerm;
	    err = (PBHOpenSync(&hpb));
	    if ( err ) return;
	    refnum = hpb.ioParam.ioRefNum;
            if (refnum < 0) return;
	    pb.ioCompletion = 0;
	    pb.ioRefNum = refnum;
	    pb.ioBuffer = NewPtr(4096);
	    pb.ioReqCount = 4096;
	    pb.ioPosMode = fsAtMark;
	    PBReadSync((ParmBlkPtr)&pb);
            err = (pb.ioResult);
            if (err && (err != -39)) return;
            argc = 0;
            for (i =0; i < pb.ioActCount;i++)
                {
                if (pb.ioBuffer[i]==' ')
                    {
                    argvec[++argc] = &pb.ioBuffer[i+1];
                    pb.ioBuffer[i] = 0;
                    }
                }
            *argvec = pb.ioBuffer;
            argvec[argc] = 0;
			{
			FCBPBRec pb;
			pb.ioRefNum = refnum;
			pb.ioCompletion = 0;
			pb.ioVRefNum = curDocFSS->vRefNum;
			PBCloseSync((ParmBlkPtr)&pb);
			}
                    {
                    OSErr err;
                    HParamBlockRec pb;
                    pb.fileParam.ioNamePtr = curDocFSS->name;
                    pb.fileParam.ioVRefNum = curDocFSS->vRefNum;
                    pb.fileParam.ioDirID = curDocFSS->parID;
                    err = PBHDeleteSync(&pb);
                    }
            }

void scanfolder(FSSpec *curDocFSS)
	{
	CInfoPBRec curDocPB;
	int i;
	FSSpec	new;
	OSErr err;
	OSErr iErr;
	curDocPB.hFileInfo.ioVRefNum = curDocFSS->vRefNum;
	curDocPB.hFileInfo.ioDirID = curDocFSS->parID;
	curDocPB.hFileInfo.ioNamePtr = curDocFSS->name;
	curDocPB.hFileInfo.ioFDirIndex = 0;	
	err = PBGetCatInfoSync (&curDocPB);
	new.parID = curDocPB.hFileInfo.ioDirID;
	new.vRefNum = curDocFSS->vRefNum;
	for (i = 1; err != fnfErr; i++) 
		{
		curDocPB.hFileInfo.ioVRefNum = new.vRefNum;
		curDocPB.hFileInfo.ioDirID = new.parID;
		curDocPB.hFileInfo.ioNamePtr = new.name;
		curDocPB.hFileInfo.ioFDirIndex = i;	
		err = PBGetCatInfoSync (&curDocPB);
		if (err == noErr)
			{
			Boolean isFolder,wasAlias;
			err = ResolveAliasFile (&new, true, &isFolder, &wasAlias);
			if (err == noErr) 
				{
				if (isFolder) scanfolder(&new);
				else ProcessDoc (&new);
				}
			}
		}
	}
