#include "crtlocal.h"
#include <sys/ioctl.h>
#include <sys/termios.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <errno.h>

#define DEBUG 0

int	ioctl __P((int fd, unsigned long cmd, ...))
	{
	va_list ap;
	void *structure;
	va_start(ap, cmd);
	structure = va_arg(ap, void *);
#if DEBUG
        kprintf("ioctl no arg = %X\n", _IO('t',0));
        kprintf("ioctl in = %X\n", _IOW('t',0, int));
        kprintf("ioctl out = %X\n", _IOR('t',0, int));
	kprintf("ioctl fd=%d\n", fd);
	kprintf("ioctl cmd=%X\n", cmd);
	kprintf("ioctl addr=%X, size = %d\n", (long)structure, IOCPARM_LEN(cmd));
	if (cmd&IOC_IN) kprintf("ioctl in\n");
#endif
	if (cmd&IOC_OUT)
		{
		memset(structure, 0, IOCPARM_LEN(cmd));
#if DEBUG
		kprintf("ioctl out\n");
#endif
		}
	va_end(cmd);
	switch(cmd)
		{
		case TIOCEXCL: /* Set exclusive TTY use */
				if (crt_fd_tab[fd].flags & S_IFCHR)
					{
					return 0;
					}
                                errno = ENOTTY;
                                return -1;
		case TIOCNXCL: /* Clear exclusive TTY use */
				if (crt_fd_tab[fd].flags & S_IFCHR)
					{
					return 0;
					}
                                errno = ENOTTY;
                                return -1;
		case TIOCGETA:
					{
					struct termios *term = structure;
					if (crt_fd_tab[fd].flags & S_IFCHR)
						{
						/* just return dummy data */
						term->c_ispeed = term->c_ospeed = B9600; 
						return 0;
						}
					}
                                errno = ENOTTY;
                                return -1;
		case TIOCSETAW:	/* drain output */
				if (crt_fd_tab[fd].flags & S_IFCHR)
					{
					return 0;
					}
                                errno = ENOTTY;
                                return -1;
		case TIOCGWINSZ:
				if (crt_fd_tab[fd].flags & S_IFCHR)
					{
					struct winsize *ws = structure;
					ws->ws_row = 25;
					ws->ws_col = 80;
					ws->ws_xpixel = 640;
					ws->ws_ypixel = 400;
					return 0;
					}
                                errno = ENOTTY;
                                return -1;
                                break;
		case TIOCSTART: /* start output */
				if (crt_fd_tab[fd].flags & S_IFCHR)
					{
					return 0;
					}
                                errno = ENOTTY;
                                break;
		case TIOCGPGRP:
				if (crt_fd_tab[fd].flags & S_IFCHR)
                                        {
					*(long *)structure = 12345;
					return 0;
                                        }
                                errno = ENOTTY;
                                break;
		}
        errno = ENODEV;
	return -1;
	}

