#include <Processes.h>
#include "Global.h"
#include "CCreateChore.h"
#include "CDRVRDirector.h"
#include <CDataFile.h>
#include "CToolArray.h"
#include "linkage.h"

extern CToolArray *gTools;
extern char	gOptions[];
Str255 defaultLibname;
FSSpec gLastTestament;
static MyBrowseResDoc *FoundRes;

static void CBrowseResSearch(CObject *theObject)
	{
	register CWindow	*theWindow = (CWindow *) theObject;
	CDirector			*theDirector = (CDirector*) theWindow->GetSupervisor();
	if (member(theDirector, MyBrowseResDoc)) 
		{
		FoundRes = (MyBrowseResDoc *)theDirector;
		}
	}

static void copyresfile(short in, short out)
	{
	short numTypes,currIndex;
	UseResFile(in);
	numTypes = Count1Types();
	for( currIndex = 1; currIndex <= numTypes; currIndex++)
		{
		short	numRes,Index;
		ResType	theType;
		Get1IndType( &theType, currIndex);
		FailOSErr(ResError());
		numRes = Count1Resources( theType);
		if (theType != 'GDOS') for( Index = 1; Index <= numRes; Index++)
			{
			short	rID;
			Str255	rName;
			Handle	aResource;
			Handle resource = Get1IndResource( theType, Index);
			FailNIL(resource);
			GetResInfo(resource,&rID,&theType,rName);
			DetachResource(resource);
			if ((theType == 'SIZE') && (rID >= -1) && (rID <= 1))
				{
				Handle pref_resource;
				extern long atol(char *);
				struct	size
					{
					unsigned short mask;
					long size,minsize;
					} temp;
				int i;
				temp.mask = 0;
				for (i = 99; i < 115; i++)
					{
					temp.mask <<= 1;
					temp.mask |= gOptions[i]&1;
					}
				pref_resource = GetResource('PREF', 3);
				FailNILRes(pref_resource);
				temp.minsize = 1024L*atol(*pref_resource);
				pref_resource = GetResource('PREF', rID+4);
				FailNILRes(pref_resource);
				temp.size = 1024L*atol(*pref_resource);
				BlockMove(&temp, *resource, sizeof(struct size));
				}

			UseResFile(out);

			aResource = Get1Resource(theType,rID);
			if (!aResource)
				{
				AddResource(resource,theType,rID,rName);
				}
			else
				{
				SetHandleSize(aResource, 0);
				HandAndHand(resource, aResource);
				ChangedResource(aResource);
				DisposHandle(resource);
				}
			UseResFile(in);
			}		
		}
	}
		
void	CCreateChore::Perform(long	*maxSleep)
	{
	if (*fspec.name)
		{
		CDataFile *theFile = new(CDataFile);
		CCreateChore	*chore = new(CCreateChore);
		theFile->IDataFile();
		theFile->SpecifyFSSpec(&fspec);
		idlechore = 0;
		chore->fspec.name[0] = 0;
		chore->idlechore = this;
		gApplication->AssignUrgentChore(chore);	
		if (theFile->ExistsOnDisk())
			{
			FInfo fndrInfo;
			if (EqualString(fspec.name,"\plibrary.$",TRUE,TRUE))
				{
				FSSpec myfile;
				short in;
				SFReply		macSFReply;				/* Standard File reply record		*/
				CDataFile	*itsFile;
				Point			corner;				/* Top left corner of dialog box	*/
				StringHandle	prompt;				/* Prompt string					*/

				FailOSErr(FSpGetFInfo(&fspec,&fndrInfo));
				fndrInfo.fdCreator = gSignature;
				fndrInfo.fdType = 'AR  ';
				FailOSErr(FSpSetFInfo(&fspec,&fndrInfo));
				
												/* Center dialog box on the screen	*/
				FindDlogPosition('DLOG', putDlgID, &corner);
				
				prompt = GetString(STRprompt);
				FailNILRes( prompt);
			
				MoveHHi( (Handle) prompt);
				HLock((Handle) prompt);
				
				if (*defaultLibname < 7) BlockMove("\plibrary_____", myfile.name, 16);
				else BlockMove(defaultLibname, myfile.name, *defaultLibname);
				BlockMove(".a", &myfile.name[*myfile.name-6], 2);
				*myfile.name -= 5;
		
				SFPPutFile(corner, *prompt, myfile.name, NULL, &macSFReply, putDlgID, NULL);
				HUnlock((Handle) prompt);
				if (!macSFReply.good) return;		
				itsFile = new(CDataFile);
				itsFile->IDataFile();
				itsFile->SFSpecify(&macSFReply);
				if (itsFile->ExistsOnDisk()) itsFile->ThrowOut();
				itsFile->GetFSSpec(&myfile);
				FailOSErr(CatMove(fspec.vRefNum,fspec.parID,fspec.name,myfile.parID,NULL));
				fspec.parID = myfile.parID;
				FailOSErr(FSpRename(&fspec,myfile.name));
				theFile->Dispose();	
				itsFile->Dispose();		
				}
			else if (EqualString(fspec.name,"\pa.out",TRUE,TRUE))	
				{
				Handle text;
				FSSpec myfile;
				FInfo info;
				short in,pref;
				short last = CurResFile();
				SFReply		macSFReply;				/* Standard File reply record		*/
				CResFile	*itsFile,*userFile;
				Point			corner;				/* Top left corner of dialog box	*/
				StringHandle	prompt;				/* Prompt string					*/
				
												/* Center dialog box on the screen	*/
				FindDlogPosition('DLOG', putDlgID, &corner);
				
				prompt = (StringHandle)GetResource('PREF', 2);
				FailNILRes( prompt);
				*fspec.name = GetHandleSize((Handle) prompt);		
				BlockMove(*(Handle)prompt, fspec.name+1, *fspec.name);
				
				prompt = GetString(STRprompt);
				FailNILRes( prompt);
			
				MoveHHi( (Handle) prompt);
				HLock((Handle) prompt);
				SFPPutFile(corner, *prompt, fspec.name, NULL, &macSFReply, putDlgID, NULL);
				HUnlock((Handle) prompt);
				if (!macSFReply.good) return;
				itsFile = new(CResFile);
				itsFile->IResFile();
				itsFile->SFSpecify(&macSFReply);
				if (itsFile->ExistsOnDisk()) itsFile->ThrowOut();
				
				prompt = (StringHandle)GetResource('PREF', 1);
				FailNILRes( prompt);		
				BlockMove(*(Handle) prompt, fspec.name, 4);
				
				itsFile->CreateNew(*(long *)fspec.name, 'APPL');
				itsFile->Open(fsRdWrPerm);
		
				for (pref = 7; pref >= 6; pref--)
					{		
					userFile = new(CResFile);
					userFile->IResFile();
					
					prompt = (StringHandle)GetResource('PREF', pref);
					FailNILRes( prompt);
					*myfile.name = GetHandleSize((Handle) prompt);		
					BlockMove(*(Handle)prompt, myfile.name+1, *myfile.name);
					SearchPaths(&myfile);
					userFile->SpecifyFSSpec(&myfile);
					if (userFile->ExistsOnDisk())
						 {
						 userFile->Open(fsRdPerm);
						 copyresfile(userFile->refNum, itsFile->refNum);
						 }
					userFile->Dispose();
					}
				theFile->Open(fsRdPerm);
				text = theFile->ReadAll();
				theFile->Close();
				theFile->ThrowOut();		
				theFile->Dispose();	
				itsFile->MakeCurrent();
				AddResource(text, 'GDOS', 0, "\pRelocatable code module");
				FailOSErr(ResError());
				WriteResource(text);
				ReleaseResource(text);
				itsFile->Dispose();		
				UseResFile(last);
				}
			else if ((fspec.name[*fspec.name]=='o') && (fspec.name[*fspec.name-1]=='.'))
				{
				Handle stub = GetResource('UNIX', 12);
				Handle text;
				FailOSErr(FSpGetFInfo(&fspec,&fndrInfo));
				fndrInfo.fdCreator = gSignature;
				fndrInfo.fdType = 'EXEC';
				FailOSErr(FSpSetFInfo(&fspec,&fndrInfo));
				theFile->Open(fsRdPerm);
				text = theFile->ReadAll();
				theFile->Close();
				DetachResource(stub);
				FailOSErr(HandAndHand(text,stub));
				FoundRes = 0;
				gDesktop->itsWindows->DoForEach(CBrowseResSearch);
				if (FoundRes)
					{
					FoundRes->AddType(stub, 'DRVR', fspec.name);
					theFile->ThrowOut();		
					}
				else
					{
					CDRVRDirector *dialog = new( CDRVRDirector);
					dialog->NewDocument( stub, gApplication, fspec.name );
					dialog->BeginDialog();			
					}
				theFile->Dispose();	
				}
			else if ((fspec.name[*fspec.name]=='i') && (fspec.name[*fspec.name-1]=='.'))
				{
				Handle	theArgs = NewHandle(256);
				Handle	strList;
				short optidx;
				SFReply 	macSFReply;
				Str63		theName;
				OSErr		theError;
				CFile		*theFile;
				Point		corner;					/* Top left corner of dialog box	*/
				Boolean		wasLocked;
				OSType 		sfFileTypes[] = {'APPL'};
													/* Center dialog box on the screen	*/

				FailOSErr(FSpGetFInfo(&fspec,&fndrInfo));
				fndrInfo.fdCreator = gSignature;
				fndrInfo.fdType = 'TEXT';
				FailOSErr(FSpSetFInfo(&fspec,&fndrInfo));

				/* ensure the STR# resource exists	*/				
				strList = GetResource( 'STR#', cmdCC1);
				FailNILRes( strList);
			
				**theArgs = 0;
				for (optidx = 1; optidx <= *(short*) *strList; optidx += 2)
					{
					Str255	theString;
					unsigned char active = gOptions[(optidx-1)>>1];
					switch(active)
						{
						case 0: case 1: break;
						case 2: active = 0; break;
						default: active += active-5; break;
						}
					GetIndString(theString,cmdCC1,optidx+active);
					if (!ResError() && theString[0])
						{		
						BlockMove(&theString[1], &((*theArgs)[1+**theArgs]), *theString);
						**theArgs += 1+*theString;
						(*theArgs)[**theArgs] = ' ';
						SetHandleSize(theArgs, 256+**theArgs);
						}
					}
				if (**theArgs)
					{
					short refnum;
					SetHandleSize(theArgs, 1+**theArgs);
					FSpCreateResFile(&fspec,gSignature,'TEXT',0);
					refnum = FSpOpenResFile(&fspec, fsWrPerm);
					if (refnum != -1)
						{
						Handle aResource = Get1Resource('STR ',12345);
						if (!aResource)
							{
							AddResource(theArgs, 'STR ', 12345, "\pargv");
							}
						else
							{
							SetHandleSize(aResource, 1+**theArgs);
							BlockMove(*theArgs, *aResource, 1+**theArgs);
							ChangedResource(aResource);
							DisposHandle(theArgs);
							}
						CloseResFile(refnum);
						}
					}
				else DisposHandle(theArgs);

				TRY
					{
					AERecord ae;
					AEDescList aeList;
					AEDesc docDesc;
					AEAddressDesc alfa;
					AliasHandle withThis;
					OSErr err;
					FSSpec theApp;
					LaunchParamBlockRec myLaunchParams;
					OSErr launchErr;
					ProcessSerialNumber defaultResult = {0};
					SetCursor(*gWatchCursor);
					
					gTools->GetItem( &theApp, gTools->selectedCell.v+1);

					myLaunchParams.launchBlockID = extendedBlock;
					myLaunchParams.launchEPBLength = extendedBlockLen;
					myLaunchParams.launchFileFlags = 0;
					myLaunchParams.launchControlFlags = launchContinue + launchNoFileFlags;
					myLaunchParams.launchAppSpec = &theApp;
					myLaunchParams.launchAppParameters = NULL;
					launchErr = LaunchApplication(&myLaunchParams);
					FailOSErr(launchErr);
					defaultResult = myLaunchParams.launchProcessSN;
					gApplication->InspectSystem();
					ASSERT (gSystem.hasAppleEvents);
					if (defaultResult.highLongOfPSN|defaultResult.lowLongOfPSN)
						{
						err = AECreateDesc(typeProcessSerialNumber,
							(Ptr) &defaultResult,
							(Size) sizeof(ProcessSerialNumber),
							&alfa);
						FailOSErr(err);
						err = AECreateAppleEvent(kCoreEventClass,
							kAEOpenDocuments,&alfa,
							kAutoGenerateReturnID,
							kAnyTransactionID,&ae);
						}
					else
						{
						ProcessInfoRec InfoRec;
						FSSpec aFSSpec;
						OSType theSig = 'ST';
						err = AECreateDesc(typeApplSignature,
							(Ptr) &theSig,
							(Size) sizeof(theSig),
							&alfa);
						FailOSErr(err);
						err = AECreateAppleEvent(kCoreEventClass,
							kAEOpenDocuments,&alfa,
							kAutoGenerateReturnID,
							kAnyTransactionID,&ae);
						FailOSErr(err);
						defaultResult.highLongOfPSN = 0;
						defaultResult.lowLongOfPSN = kNoProcess;
						
						InfoRec.processInfoLength = sizeof(ProcessInfoRec);
						InfoRec.processName = (StringPtr) NewPtr(32);
						InfoRec.processAppSpec = &aFSSpec;
						
						while ((GetNextProcess(&defaultResult) == noErr) &&
							  (defaultResult.highLongOfPSN|defaultResult.lowLongOfPSN) &&
							  (GetProcessInformation(&defaultResult,&InfoRec) == noErr) &&
							  ((InfoRec.processType != 'APPL') ||
								(InfoRec.processSignature != theSig)))
									;
						}
					err = AECreateList(NULL,0,FALSE,&aeList);
					FailOSErr(err);
					NewAlias(NULL,&fspec,&withThis);
					HLock((Handle) withThis);
					err = AECreateDesc(typeAlias,(Ptr) *withThis, GetHandleSize((Handle) withThis),
						&docDesc);
					FailOSErr(err);
					HUnlock((Handle) withThis);
					err = AEPutDesc(&aeList,0,&docDesc);
					FailOSErr(err);
					err = AEPutParamDesc(&ae,keyDirectObject,&aeList);
					FailOSErr(err);
					err = AESend(&ae,NULL,kAENoReply,kAENormalPriority,0,NULL,NULL);
					FailOSErr(err);
					if (!err) 
						{
						SetFrontProcess(&defaultResult);
						gLastTestament = fspec;
						gLastTestament.name[*gLastTestament.name]='s';
						}
					}
				CATCH
					{
					fspec.name[0] = 0;
					}
				ENDTRY;
				}
			else if (EqualString(fspec.name,"\plibrary.a",TRUE,TRUE))	/* assume empty library */
				{
				theFile->ThrowOut();		
				theFile->Dispose();	
				}
			else 
				{
				GNUEditDoc	*theDocument = NULL;
				Handle theData = NULL;
				FailOSErr(FSpGetFInfo(&fspec,&fndrInfo));
				fndrInfo.fdCreator = gSignature;
				fndrInfo.fdType = 'TEXT';
				FailOSErr(FSpSetFInfo(&fspec,&fndrInfo));				
				TRY
					{
					theFile->Open(fsRdPerm);
					theData = theFile->ReadAll();
					theDocument = new(GNUEditDoc);
					theDocument->IGNUEditDoc(gApplication, TRUE);
					theDocument->NewFilefromHandle(theData);
					theDocument->itsWindow->SetTitle(fspec.name);
					theDocument->itsFile = theFile;
					}
				CATCH
					{
					ForgetObject( theDocument);
					}
				ENDTRY;
				}
			}
		*fspec.name = 0;
		}
	else if (idlechore)
		gApplication->CancelIdleChore(idlechore);
	*maxSleep = 999999999;	/* no hurry to do this again */
	}
