#include "crtlocal.h"
#include <sys/types.h>
#include <sys/syslimits.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <Resources.h>

int chown(const char *name, uid_t owner, gid_t group)
		{
    	OSErr   err;
    	FInfo info;
    	FSSpec name1 = hfs_canon(crt, name, 1);
    	if (!*name1.name) return -1;
    	err = errtran(FSpGetFInfo(&name1, &info));
        if (!err)
        	{
        	info.fdCreator = (owner<<16)|(group&0xFFFF);
        	info.fdType = 'TEXT';
        	err = errtran(FSpSetFInfo(&name1, &info));
        	}
    	return err?-1:0;
		}
	
int copyresfile(short in, short out)
	{
	short numTypes,currIndex;
	UseResFile(in);
	numTypes = Count1Types();
	for( currIndex = 1; currIndex <= numTypes; currIndex++)
		{
		short	numRes,Index;
		ResType	theType;
		Get1IndType( &theType, currIndex);
		if (ResError()) return -1;
		numRes = Count1Resources( theType);
		for( Index = 1; Index <= numRes; Index++)
			{
			short	rID;
			Str255	rName;
			Handle	aResource;
			Handle resource = Get1IndResource( theType, Index);
			if (!resource) return -1;
			GetResInfo(resource,&rID,&theType,rName);
			DetachResource(resource);
/*
			if ((theType == 'SIZE') && (rID >= -1) && (rID <= 1))
				{
				Handle pref_resource;
				extern long atol(char *);
				struct	size
					{
					unsigned short mask;
					long size,minsize;
					} temp;
				int i;
				temp.mask = 0;
				for (i = 99; i < 115; i++)
					{
					temp.mask <<= 1;
					temp.mask |= gOptions[i]&1;
					}
				pref_resource = GetResource('PREF', 3);
				FailNILRes(pref_resource);
				temp.minsize = 1024L*atol(*pref_resource);
				pref_resource = GetResource('PREF', rID+4);
				FailNILRes(pref_resource);
				temp.size = 1024L*atol(*pref_resource);
				BlockMove(&temp, *resource, sizeof(struct size));
				}
*/
			UseResFile(out);

			aResource = Get1Resource(theType,rID);
			if (!aResource)
				{
				AddResource(resource,theType,rID,rName);
				}
			else
				{
				SetHandleSize(aResource, 0);
				HandAndHand(resource, aResource);
				ChangedResource(aResource);
				DisposHandle(resource);
				}
			UseResFile(in);
			}		
		}
	}

int open(const char *name, int flags, ...)
	{
        OSErr err;
	int fd,refnum;
        FSSpec name1 = hfs_canon(crt, name, 1);
        if (!*name1.name) return -1;
	mysleep(1);
	if (flags & O_CREAT) 
		{
		FSpDelete(&name1);
		if (!memcmp(name1.name,"\pa.out",6))
			{
			short out;
			Handle aResource = Get1Resource('CODE', 0);
			short last = CurResFile();
			short in = HomeResFile(aResource);
			FSpCreateResFile(&name1,'TEST','APPL',0);
			out = FSpOpenResFile(&name1,fsWrPerm);
			copyresfile(in,out);
			UseResFile(last);
			CloseResFile(out);
			}
		else
			{
#if 0
                HParamBlockRec pb;
    		pb.ioParam.ioNamePtr = name1.name;
	    	pb.ioParam.ioVRefNum = name1.vRefNum;
	    	pb.fileParam.ioDirID = name1.parID;
	        err = errtran(PBHCreateSync(&pb));
	        if (!err)
	        	{
		    	OSErr   err;
		    	FInfo info;
    			err = errtran(FSpGetFInfo(&name1, &info));
		        if (!err)
		        	{
		        	info.fdCreator = 'R*ch';
		        	info.fdType = 'TEXT';
		        	err = errtran(FSpSetFInfo(&name1, &info));
		        	}
	        	}
#else
			err = errtran(FSpCreate(&name1,'R*ch','TEXT',0));
#endif
                        if (err) return -1;
			}
        }
	else
		{
		struct stat statbuf;
		err = errtran(macstat(name1.name, &statbuf, name1.vRefNum, name1.parID));
		if (err) return -1;
		if (S_ISDIR(statbuf.st_mode))
			{
		    fd = next_fd(3);
		    crt_fd_tab[fd].fd = statbuf.st_ino;
		    crt_fd_tab[fd].flags = S_IFDIR;
			return fd;
			}
		}
        {
        HParamBlockRec pb;
        pb.ioParam.ioNamePtr = name1.name;
        pb.ioParam.ioVRefNum = name1.vRefNum;
        pb.fileParam.ioDirID = name1.parID;
        pb.ioParam.ioPermssn = flags&(O_WRONLY|O_RDWR)?fsCurPerm:fsRdPerm;
        err = errtran(PBHOpenSync(&pb));
        if ( err ) return -1;
        refnum = pb.ioParam.ioRefNum;
        }
	if (flags & O_APPEND)
		{
                HParamBlockRec pb;
                pb.ioParam.ioRefNum = refnum;
                pb.ioParam.ioPosMode = fsFromLEOF;
                pb.ioParam.ioPosOffset = 0;
                (void)PBSetFPosSync((ParmBlkPtr)&pb);
		}
	if (flags & O_TRUNC)
		{
                HParamBlockRec pb;
		pb.ioParam.ioCompletion = 0;
		pb.ioParam.ioRefNum = refnum;
		pb.ioParam.ioMisc = 0;
		PBSetEOFSync((ParmBlkPtr)&pb);
                }
    fd = next_fd(3);
    crt_fd_tab[fd].fd = refnum;
    crt_fd_tab[fd].flags = (flags&~S_IFMT)|S_IFREG;
	return fd;
	}

int	creat(const char *name, mode_t mode)
	{
	return open(name, O_CREAT|O_TRUNC|O_WRONLY, mode);
	}
