#include "crtlocal.h"
#include <sys/param.h>
#include <sys/stat.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <Aliases.h>

int unlink(const char *name)
	{
	long filenum;
	int i;
	OSErr err;
    HParamBlockRec pb;
    FSSpec name1 = hfs_canon(crt, name, 0);
    if (!*name1.name) return -1;
    pb.fileParam.ioNamePtr = name1.name;
    pb.fileParam.ioVRefNum = name1.vRefNum;
    pb.fileParam.ioDirID = name1.parID;
	err = PBHDeleteSync(&pb);
	if (err) errno = errtran(err);
	return err?-1:0;
	}

int symlink(const char *old, const char *new)
	{
	int err;
	FSSpec oldspec = hfs_canon(crt, old, 1);
	FSSpec newspec = hfs_canon(crt, new, 0);
    if (!*oldspec.name) return -1;
    if (!*newspec.name) return -1;
    return -1;
	}
	
int readlink(const char *old, char *new, int len)
	{
	int err;
	long tmp;
        FSSpec tmp2;
	char str[MAXPATHLEN];
	Boolean	targetIsFolder,wasAliased;
	FSSpec canon = hfs_canon(crt, old, 0);
    if (!*canon.name) return -1;
	err = errtran(ResolveAliasFile(&canon,true,&targetIsFolder,&wasAliased));
	if (err) return -1;
	if (!wasAliased)
		{
		errno = ENOENT;
		return -1;
		}
	tmp2 = crt;
	crt = canon;
	getwd(str);
	crt = tmp2;
	len = strlen(str);
	tmp = *canon.name;
	*canon.name = '/';
	strncpy(&str[len], (char *)canon.name, tmp+1);
	len += tmp+1;
	str[len] = 0;
	strncpy(new, str, len);
    return len;
	}
